<template>
  <a-modal
    v-model:visible="show"
    :width="width"
    :title="title"
    centered
    @ok="show = false"
  >
    <template #footer>
      <a-button class="ant-btn-outlined" @click="show = false">{{
        cancelButtonText
      }}</a-button>
      <a-button class="ant-btn-purple">{{ confirmButtonText }}</a-button>
    </template>
    <slot name="body" />
  </a-modal>
</template>
<script setup lang="ts">
import { ref, toRefs, watch } from 'vue';

const props = defineProps({
  visible: {
    type: Boolean,
    default: false,
  },
  width: {
    type: String,
    default: '720px',
  },
  title: {
    type: String,
    default: 'Voulez-vous vraiment supprimer ce plan ?',
  },
  cancelButtonText: {
    type: String,
    default: 'Annuler',
  },
  confirmButtonText: {
    type: String,
    default: 'Supprimer',
  },
});
const emits = defineEmits(['close-modal']);
let show = ref<boolean>(false);
const allProps = toRefs(props);
const visible = allProps.visible;
watch(visible, (val) => {
  show.value = val;
});
watch(show, (val) => {
  show.value = val;
  if (!val) {
    emits('close-modal');
  }
});
</script>
<script lang="ts">
export default {
  name: 'ModalComponent',
};
</script>
